Hdu 4791 Alice's Print Service(二分)

Alice is providing print service, while the pricing doesn’t seem to be reasonable, so people using her print service found some tricks to save money.
For example, the price when printing less than 100 pages is 20 cents per page, but when printing not less than 100 pages, you just need to pay only 10 cents per page. It’s easy to figure out that if you want to print 99 pages, the best choice is to print an extra blank page so that the money you need to pay is 100 × 10 cents instead of 99 × 20 cents.
Now given the description of pricing strategy and some queries, your task is to figure out the best ways to complete those queries in order to save money.
Input
The first line contains an integer T (≈ 10) which is the number of test cases. Then T cases follow.
Each case contains 3 lines. The first line contains two integers n, m (0 < n, m ≤ 10 5 ). The second line contains 2n integers s 1, p 1 , s 2, p 2 , …, s n, p n (0=s 1 < s 2 < … < s n ≤ 10 9 , 10 9 ≥ p 1 ≥ p 2 ≥ … ≥ p n ≥ 0)… The price when printing no less than s i but less than s i+1 pages is p i cents per page (for i=1…n-1). The price when printing no less than s n pages is p n cents per page. The third line containing m integers q 1 … q m (0 ≤ q i ≤ 10 9 ) are the queries.
Output
For each query q i, you should output the minimum amount of money (in cents) to pay if you want to print q i pages, one output in one line.
Sample Input
1
2 3
0 20 100 10
0 99 100
Sample Output
0
1000
1000

题目大意:去打印店进行打印,每个规定范围 有规定的价格,页数不够可以用白纸凑
解题思路:
1,先找到每个规定的局部最优;
2,再用二分缩小范围;
3,求得最优解!

代码如下:

#include<stdio.h>

typedef long long int ll;

ll min(ll a,ll b);

const int N = 100005;

ll price[N+10];         //价格

ll sum[N+10];           //页数局部最优的金额

ll num[N+10];           //页数

int main()
{
    int T;
    int n,m;
    scanf("%d",&T);
    while(T--)
    {
        scanf("%d%d",&n,&m);
        int i;
        for(i = 0 ; i < n ; i++)
        {
            scanf("%lld%lld",&num[i],&price[i]);
        }
        sum[n-1]=num[n-1]*price[n-1];
        for(i=n-2;i>=0;i--)                         //局部最优(因为可能出现10 50 20 15 的情况,要保证输入10的时候输出300)
            sum[i]=min(sum[i+1],num[i]*price[i]);
        ll q;
        for(i = 0 ; i < m ; i++)
        {
            scanf("%lld",&q);
            if(q >= num[n-1])
            {
                printf("%lld\n",q*price[n-1]);
                continue;
            }
            int l = 0 , r = n-1 , mid;
            while(l < r)                            //二分
            {
                mid = (l+r)/2;
                if(q == num[mid])
                {
                    printf("%lld\n",sum[mid]);
                    break;
                }
                else if(q > num[mid])
                {
                    if(q < num[mid+1])
                    {
                        printf("%lld\n",min(q*price[mid],sum[mid+1]));
                        break;
                    }
                    else if(q == num[mid+1])
                    {
                        printf("%lld\n",sum[mid+1]);
                        break;
                    }
                    else
                        l = mid;
                }
                else
                {
                    r = mid;
                }
            }

        }
    }
    return 0;
}

ll min(ll a,ll b)
{
    return a<b?a:b;
}

猜你喜欢

转载自blog.csdn.net/shuati2000/article/details/99999129
今日推荐